/* eLXgGNX|[g.jsx
 * Skyward Design JavaScript Library for Photoshop
 * PSDt@C̃eLXgC[̓eAeLXgt@Cɏo܂B
 * 
 * Version 1.0.2
 * Copyright (C) 2010 Hideki Abe
 */
(function(activeDocument) {
    // IvVݒ
    var options = {
        // s
        linefeed : String.fromCharCode(13),
        
        // Zp[g
        separator : "------------------------------------------------------",
        
        // o̓C[ړ
        // Version 1.0.2ł͖gp
        targetname : "w_"
    };
    
    function main() {
        var fileName = File.saveDialog("ۑt@CĂ");
        if(fileName) {
            // t@C쐬AeLXgC[o
            var file = new File(fileName);
            var openFlag = file.open("w");
            if(openFlag) {
                // t@C񐶐
                var date = new Date();
                var fileInfo = activeDocument.name + options.linefeed + "Generated: " + date + 
                               options.linefeed + options.linefeed + options.linefeed + 
                               "********** Output Start **********" + options.linefeed + options.linefeed;
                file.write(fileInfo);
                
                // C[o
                _scanLayer(file, activeDocument);
                file.close();
                alert("o܂B");
            } else {
                alert("t@CJ܂łB");
            }
        } else {
            alert("𒆎~܂B");
        }
    }
    
    // C[XLEo
    function _scanLayer(file, target, layerpath) {
        // LayersIuWFNg擾
        var targetLayers = target.layers;
        var nLayer = targetLayers.length;
        var path = layerpath || "root";
        
        for(var i = 0; i < nLayer; i++) {
            if(targetLayers[i].typename === "LayerSet") {
                // C[Zbg̏ꍇ
                // C[Zbgo͌ċA
                var tmpPath = path + " > " + targetLayers[i].name;
                var text = options.separator + options.linefeed + 
                           "Layerset: " + targetLayers[i].name + options.linefeed + 
                           "  Path: " + tmpPath + options.linefeed + 
                           options.separator + options.linefeed;
                file.write(text);
                _scanLayer(file, targetLayers[i], tmpPath);
            } else if(targetLayers[i].kind === LayerKind.TEXT) {
                // eLXgC[̏ꍇ
                var text = targetLayers[i].textItem.contents;
                file.write(text + options.linefeed + options.linefeed);
            }
        }
        
        file.write(options.linefeed);
    }
    
    // Dispatch
    main();
    
})(activeDocument);
